#! /usr/bin/perl
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {		# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
$datastring =~s/%0D%0A/\n/g;                    			#step to deal with line
																											#breaks in text areas
@nameValuePairs = split(/&/, $datastring);						#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);								#step 2
  
  $name =~tr/+/ /;                                 		#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 		#step 3
  $value =~tr/+/ /;                                		#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;		#step 3
  
  if(exists $formHash{$name}) {												#improved step 4,
    $formHash{$name} = $formHash{$name}.";".$value;		#now handles multiple
  }																										#select menus
  else {
    $formHash{$name} = $value;
  }   	
}
###done decoding###############################################


### global variables ##########################################
use DBI;
$dbhandle = DBI->connect("DBI:mysql:deptstore", "book", "bookpass")  
  or &errorPage("Can't connect to database. ". DBI->errstr()); 

### end global variables ######################################

### app logic #################################################
if($formHash{"request"} eq "search") {
	&search;
}
else {
	&search_page;
}
### end app logic #############################################

###############################################################
sub search_page {
 	print<<TOP;
 	<html><head><title>Search our sports store</title></head><body>
TOP

	&searchForm; # no argument --> no hardcoded values for search form

 	print<<BOTTOM;
 	</body></html>
BOTTOM
}

###############################################################
sub searchForm {
  my ($initialstring, $wholewordon) = @_;
  
  my $checked_or_not = "";
  if($wholewordon){
  	$checked_or_not = 'checked="checked"';
  }
  print<<FORM;
  <form action="$ENV{'SCRIPT_NAME'}" method="GET">
   Search for 
   <input type="text" name="searchstring" value="$initialstring" size="15"/><br/>
   <input type="submit" value="Search for products"/><br/>
   <input type="checkbox" name="wholeword" value="on" $checked_or_not/> Match whole words only
   <input type="hidden" name="request" value="search"/>
  </form>
FORM
}

###############################################################
sub search {
 ### This function uses SQL extension RLIKE

 $searchstring = $formHash{"searchstring"};

 if($formHash{"wholeword"}) {
   $searchstring = '(^|[^a-zA-Z])'.$searchstring.'($|[^a-zA-Z])';
 }
 print<<TOP;
 <html><head><title>Results of your search</title></head><body>
  <h2>Here are the results of your search:</h2>
  <ol>
TOP

  my $sql = "SELECT item FROM products WHERE item RLIKE '$searchstring'";
  my $qObj= $dbhandle -> prepare($sql) or &errorPage("Can't prepare ");
  $qObj-> execute() or &errorPage("Can't execute " . $qObj->errstr());

  my @row;
  my @matches = ();
  while(@row =  $qObj->fetchrow_array()){
    push @matches, $row[0];
  }
  $qObj-> finish();
 
 foreach $match (@matches){
     print "<li>$match</li>\n";
 }
 print "</ol>\n";

 &searchForm($formHash{"searchstring"}, $formHash{"wholeword"});

 print<<BOTTOM;
 </body></html>
BOTTOM
}


#################################################################
sub errorPage {
 my $message = $_[0];  # optional message parameter
 
 print<<ALL;
 <html><head><title>Server Error</title></head><body>
  <h2>Server Error Encountered</h2>
  $message 
  
  If the problem persists, please notify the <a href="mailto:admin\@uweb.edu">webmaster</a>.
 </body></html>
ALL
 
	exit;   # terminate program since failure to open data file
}
